package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.ContactUs;
import com.izouma.awesomeadmin.service.ContactUsService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/contactUs")
@RequiresAuthentication
public class ContactUsController {

    @Autowired
    private ContactUsService contactUsService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(ContactUs record) {
        List<ContactUs> pp = contactUsService.getContactUsList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getContactUs", method = RequestMethod.GET)
    @ResponseBody
    public Result getContactUs(@RequestParam(required = false, value = "id") String id) {
        ContactUs data = contactUsService.getContactUsById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(ContactUs record) {
        ContactUs data = contactUsService.getContactUs(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, ContactUs record) {
        Map<String, Object> result = new HashMap<>();

        List<ContactUs> pp =contactUsService.getContactUsByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(ContactUs record) {
        boolean num = contactUsService.createContactUs(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateContactUs(ContactUs record) {
        boolean num = contactUsService.updateContactUs(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteContactUs(@RequestParam(required = true, value = "id") String id) {

        boolean num = contactUsService.deleteContactUs(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, ContactUs record) throws Exception {

    List<ContactUs> contactUss = contactUsService.getContactUsList(record);


        String sheetName = "contact_us";
        String titleName = "联系我们数据表";
        String fileName = "联系我们表";
        int columnNumber = 11;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "公司名称" ,   "电话" ,   "传真" ,   "邮编" ,   "地址"  };
        String[][] dataList = new String[contactUss.size()][11];

        for (int i = 0; i < contactUss.size(); i++) {

                        dataList[i][0] = String.valueOf(contactUss.get(i).getId());
                        dataList[i][1] = String.valueOf(contactUss.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(contactUss.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(contactUss.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(contactUss.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(contactUss.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(contactUss.get(i).getCompanyName());
                        dataList[i][7] = String.valueOf(contactUss.get(i).getTelephone());
                        dataList[i][8] = String.valueOf(contactUss.get(i).getFaxes());
                        dataList[i][9] = String.valueOf(contactUss.get(i).getPostcode());
                        dataList[i][10] = String.valueOf(contactUss.get(i).getAddress());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

